package jartege ; 

import java.lang.reflect.* ; 
import java.util.* ; 
import java.io.* ; 


/**
 * Classe des constructeurs.
 */

class Constructeur extends Operation {

   // L'objet de type Constructor reprsent par ce constructeur
   Constructor theConstructor ; 

   // Constructeur
   Constructeur(Constructor cons, Classe laClasse) {
      super(laClasse) ; 
      setNomComplet(cons.getName()) ; 
      theConstructor = cons ; 
      calculeVecteurMGP() ; 
   }

   // Le type des paramtres de retour de ce constructeur
   Class[] typeParametres() {
      return theConstructor.getParameterTypes() ; 
   }

   // Le type de retour de ce constructeur
   Class typeRetour() {
      return theConstructor.getDeclaringClass() ; 
   }

   boolean estConstructeur() {
      return true ; 
   }

   boolean estStatique() {
      return Modifier.isStatic(theConstructor.getModifiers()) ;
   }

   Class[] typesExceptions() {
      return theConstructor.getExceptionTypes() ; 
   }

   /**
    * Evaluation d'un appel de constructeur.
    */

   Object eval(Appel appel) throws 
         InstantiationException, IllegalAccessException,
         IllegalArgumentException, InvocationTargetException {
      return theConstructor.newInstance(appel.getValeurTabParam()) ; 
   }

  

   /**
    * Chaine de caractres correspondant  cet appel.
    */

   String toString(Appel appel) {
      String res = "new " + getNomComplet() + "(" ;
      Expression[] param = appel.getTabParam() ; 
      for (int i = 0 ; i < param.length ; i++) {
         if (i != 0) {
            res = res + ", " ;
         }
         res = res + param[i].toString() ;
      }
      res = res + ")" ;
      return res ;
   }


}

