package jartege ; 

/**
 * Classe des expressions.
 */

abstract class Expression {

   // Valeur de cette expression
   Object valeur ; 

   // La classe reprsentant le type de cette expression
   Classe laClasse ;

   // Objet servant de parametre implicite aux methodes de generation
   // de parametre
   Object objetMGP ;

   // est vrai ssi la valeur a dj t calcule
   boolean calcule ; 

   /**
    * Constructeur.
    */
   Expression() {
      calcule = false ; 
      valeur = null ; 
   }

   /**
    * Evalue l'expression.
    */
   public abstract Object eval() ; 

   /**
    * Retourne la valeur de l'expression.
    */
   public Object getValeur() {
      if (!calcule) {
         calcule = true ; 
         valeur = eval() ; 
      }
      return valeur ; 
   }

   /**
    * L'expression sous forme de chaine de caracteres.
    */
   public abstract String toString() ; 

}

