
package jartege ; 

/**
 * Cette classe permet de simuler l'imbrication de n boucles for
 *  l'aide d'un itrateur.
 *
 * Soit un itrateur construit par
 *    IndexIterator it = new IndexIterator(max) 
 * o max est un tableau d'entiers positifs ou nuls.
 *
 * L'itrateur it permet d'enumerer l'ensemble des n-uplets de la forme 
 * (res[0], res[1], ... res[n - 1]) tels que 
 *    . n = max.lenth
 *    . pour tout i, 0 <= res[i] <= max[i] - 1
 */

class IndexIterator {

   // Le nombre d'indices  gnrer
   final private int n ; 

   // La valeur maximale de chaque indice
   final private int[] max ; 

   // fini est vrai ssi on a atteint le dernier n-uplet
   boolean fini ; 

   // Le n-uplet courant
   private int[] cour ; 

   /**
    * Constructeur.
    */

   IndexIterator(int[] max) {
      this.n = max.length ; 
      this.max = new int[n] ; 
      this.cour = new int[n] ;
      for (int i = 0 ; i < n ; i++) {
         this.max[i] = max[i] ; 
         this.cour[i] = 0 ; 
      }
      fini = false ; 
      for (int i = 0 ; i < n ; i++) {
         fini = fini || max[i] == 0 ; 
      }
   }

   /**
    * Teste s'il reste des n-uplets  numrer.
    */

   public boolean hasNext() {
      return !fini ; 
   }

   /**
    * Renvoie le prochain n-uplet.
    */

   public int[] next() {
      int[] resultat ; 
      if (fini) {
         resultat = null ; 
      } else {
         // Construction du rsultat
         resultat = new int[n] ; 
         for (int i = 0 ; i < n ; i++) {
            resultat[i] = cour[i] ; 
         }
         // On calcule le prochain n-uplet
         // Niveau courant
         int niv = n - 1 ; 
         // On remonte dans l'arbre au niveau o on doit incrmenter
         // l'indice        
         while (niv >= 0 && cour[niv] == max[niv] - 1) {
            niv-- ;
         }
         if (niv == -1) {
            fini = true ; 
         } else {
            // On incrmente l'indice
            cour[niv]++ ; 
            // Les indices de niveau suprieurs sont mis  0
            for (int i = niv + 1 ; i < n ; i++) {
               cour[i] = 0 ; 
            }
         }
      }
      return resultat ; 

   }
   
}

