package jartege ; 

import java.lang.reflect.* ; 
import java.util.* ; 
import java.io.* ; 

class OperationGet extends Operation {

   // Le champ correspondant  cette opration get
   Field theField ; 

   // Constructeur
   OperationGet(Field theField, Classe laClasse) {
      super(laClasse) ; 
      this.theField = theField ; 
      setNomComplet("get" + theField.getName()) ; 
   }
      
   // Le type des paramtres
   Class[] typeParametres() {
      return new Class[0] ; 
   }
   // Le type de retour de cette opration 
   Class typeRetour() {
      return theField.getType() ; 
   }

   // Vrai ssi l'attribut est un attribut de classe
   boolean estStatique() {
      return Modifier.isStatic(theField.getModifiers()) ;
   }

   /**
    * Evaluation d'un appel de cette operation get.
    */
   Object eval(Appel appel) throws 
         IllegalArgumentException, IllegalAccessException {
      return theField.get(appel.getValeurParamImpl()) ; 
   }


   /**
    * Chaine de caractres correspondant  cet appel.
    */

   String toString(Appel appel) {
      String res = "" ;
      if (estStatique()) {
         res = res + laClasse.getNom() ;
      } else {
         res = res + appel.getParamImpl().toString() ;
      }
      res = res + "." + theField.getName() ;
      return res ;
   }


   public String toString() {
      String res = typeRetour().getName() + " <get>" + 
         theField.getName() + "()" ; 
      return res ; 
   }
}

