package jartege ; 

import java.io.* ;

/**
 * Class of range size generators.
 * A range size generator is an object generator which allows one 
 * to generate object according to a size in a specified range.
 */

class RangeSizeGenerator extends SizeGenerator {

   // The minimum size of object generated by this range size generator.
   int minSize ; 
   // The maximum size of object generated by this range size generator.
   int maxSize ; 

   /**
    * Constructor.
    * Constructs a range size generator with the specified size.
    */
   public RangeSizeGenerator(int minSize, int maxSize) {
      super() ; 
      this.minSize = minSize ; 
      this.maxSize = maxSize ; 
   }

   /**
    * Returns the minimum size of this range size generator.
    */
   public int getMinSize() {
      return minSize ; 
   }

   /**
    * Returns the maximum size of this range size generator.
    */
   public int getMaxSize() {
      return maxSize ;
   }


   /**
    * Sets the minimum size of this range size generator to the specified 
    * mimimum size.
    */
   public void setMinSize(int minSize) {
      this.minSize = minSize ; 
   }

   /**
    * Sets the maximum size of this range size generator to the specified 
    * maximum size.
    */
   public void setMaxSize(int maxSize) {
      this.maxSize = maxSize ;
   }

   /**
    * Generates one object of the class associated with this object
    * generator.
    * @param nonNull if nonNull = false, then the method may generate
    *                a null object.
    * @param file the generated file
    */

   Expression generateAnObject(boolean nonNull, FileWriter file)
      throws IOException {
      System.err.println
         ("RangeSizeGenerator.generateAnObject : non implemente") ;
      throw new RuntimeException() ;
   }


}

