package jartege ; 

import org.jmlspecs.jmlrac.runtime.* ; 

/**
 * Classe des rsultats d'appels qui lvent une exception.
 */

class ResultatException extends Element {

   // L'exception qui a t leve
   Throwable theExcept ; 

   /**
    * Constructeur.
    */
   ResultatException(Throwable theExcept) {
      this.theExcept = theExcept ; 
      setNomComplet(theExcept.getClass().getName()) ; 
   }

   /**
    * Teste si l'exception est une instance de l'une des classes du 
    * tableau de classes tab.
    */
   boolean estInstance(Class[] tab) {
      boolean ok = false ; 
      for (int i = 0 ; i < tab.length && !ok ; i++) {
         if (tab[i].isAssignableFrom(theExcept.getClass())) {
            ok = true ; 
         }
      }
      return ok ; 
   }

   /**
    * Teste si l'exception correspond  une erreur de prcondition 
    * d'entre d'une mthode.
    */
   static boolean precondErreur(Object obj) {
      if (obj != null && obj instanceof ResultatException) {
         ResultatException resExcept = (ResultatException) obj ; 
         return resExcept.theExcept instanceof JMLEntryPreconditionError ; 
      } else {
         return false ; 
      }
   } 
}

